<?php
class Domain
{
	public $id;
	public $id_project;
	public $name;
	public $fqdn;
	public $policy;
	public $enumered;
	public $axfred;

	public function __construct($id = 0)
	{
		$id = intval($id);

		if ($id !== 0)
		{
			$this->id = $id;
			$this->load();
		}
		else return False;
	}

	public function listAll()
	{
		global $_db, $_project;

		return $_db->query('SELECT * FROM domains WHERE id_project='. $_project->id .' ORDER BY name');
	}

	function insert()
	{
		global $_db, $_project;

		$this->id_project = intval($this->id_project);
		$this->name = mysql_real_escape_string($this->name);
		$this->fqdn = mysql_real_escape_string($this->fqdn);
		$this->policy = mysql_real_escape_string($this->policy);
		$this->enumered = intval($this->enumered);
		$this->axfred = intval($this->axfred);

		$vars = array('id_project' => $this->id_project,
			'name' => $this->name,
			'fqdn' => $this->fqdn,
			'policy' => $this->policy,
			'enumered' => $this->enumered,
			'axfred' => $this->axfred
			);
		
		$this->id = $_db->insert_unique('domains', $vars);

		return $this->id;
	}

	function update()
	{
		global $_db, $_project;

		$this->id_project = intval($this->id_project);
		$this->name = mysql_real_escape_string($this->name);
		$this->fqdn = mysql_real_escape_string($this->fqdn);
		$this->policy = mysql_real_escape_string($this->policy);
		$this->enumered = intval($this->enumered);
		$this->axfred = intval($this->axfred);

		$res = $_db->query("UPDATE domains SET id_project=$this->id_project, name='$this->name', fqdn='$this->fqdn', policy='$this->policy', enumered=$this->enumered, axfred=$this->axfred WHERE id=$this->id AND id_project=$this->id_project");

		return $res;
	}

	function load()
	{
		global $_db, $_project;

		$res = $_db->query('SELECT * FROM domains WHERE id='. $this->id .' AND id_project='. $_project->id);
		if ($res)
		{
			$this->id_project = $res[$this->id]['id_project'];
			$this->name = $res[$this->id]['name'];
			$this->fqdn = $res[$this->id]['fqdn'];
			$this->policy = $res[$this->id]['policy'];
			$this->enumered = $res[$this->id]['enumered'];
			$this->axfred = $res[$this->id]['axfred'];
		}
	}

	function getFqdns()
	{
		global $_db, $_project;

		$res = $_db->query('SELECT * FROM domains WHERE id_project='. $_project->id);

		return $res;
	}

	function getByDnsIp($ipaddr)
	{
		global $_db, $_project;

		$res = $_db->getid('SELECT id_domain AS id FROM hosts WHERE ipaddr=\''. $ipaddr .'\' AND id_project='. $_project->id);

		if (is_int($res))
			return new Domain($res);

		return False;
	}

	function listHosts()
	{
		global $_db, $_project;

		$res = $_db->query("SELECT * FROM hosts WHERE id_project=$_project->id AND id_domain=$this->id ORDER BY ipaddr");

		return $res;
	}

	function listUsers()
	{
		global $_db, $_project;

		$res = $_db->query("SELECT * FROM users WHERE id_project=$_project->id AND id_domain=$this->id ORDER BY rid");

		return $res;
	}

	function listGroups()
	{
		global $_db, $_project;

		$res = $_db->query("SELECT g.id, g.rid, g.name, COUNT(u.id_user) AS nb FROM usergroups u, groups g ".
							"WHERE u.id_project=$_project->id AND u.id_domain=$this->id ".
							"AND g.id=u.id_group GROUP BY g.rid ORDER BY name");

		return $res;
	}

	function getPolicy()
	{
		global $_project;

		if (empty($this->policy) AND file_exists('../modules/policy.php'))
		{
			include_once '../modules/policy.php';

			$dns = $_project->getHostsByRole('Domain Controller');
			foreach ($dns AS $id_host => $d)
			{
				$this->policy = do_policy($this, $d['ipaddr']);

				if (!empty($this->policy))
					return $this->policy;
			}
		}
		return '';
	}
}
?>
