<?php
class Host
{
	public $id;
	public $id_project;
	public $id_domain;
	public $name;
	public $ipaddr;
	public $os;
	
	public $domain_id;
	public $domain_name;
	public $domain_fqdn;
	
	public $roles = array();
	public $appusers = array();
	
	public function __construct($id = 0)
	{
		$id = intval($id);
		
		if ($id !== 0)
		{
			$this->id = $id;
			$this->load();
		}
		else return False;
	}
	
	public function listAll()
	{
		global $_db, $_project;
		
		return $_db->query('SELECT * FROM hosts WHERE id_project='. $_project->id .' ORDER BY ipaddr');
	}
	
	public function listBySubnet()
	{
		global $_db, $_project;
		
		$hosts = $_db->query('SELECT h.id, h.name, h.ipaddr, d.id AS domain_id, d.name AS domain_name, d.fqdn AS domain_fqdn
			FROM hosts h LEFT JOIN domains d ON (h.id_domain = d.id) WHERE h.id_project='. $_project->id); 
		
		$ret = array();
		foreach ($hosts as $h)
			$ret[slash24($h['ipaddr'])][] = $h;

		return $ret;
	}
	
	public function getByIp($ip)
	{
		global $_db, $_project;
		
		$res = $_db->query('SELECT * FROM hosts WHERE ipaddr=\''. $ip .'\' AND id_project='. $_project->id .' LIMIT 1');
		
		$keys = array_keys($res);
		
		if (count($keys))
		{
			$id_host = intval($keys[0]);
			
			if (isset($res[$id_host]))
			{
				$h = new Host();
				$h->id = $res[$id_host]['id'];
				$h->id_project = $res[$id_host]['id_project'];
				$h->id_domain = $res[$id_host]['id_domain'];
				$h->name = $res[$id_host]['name'];
				$h->ipaddr = $res[$id_host]['ipaddr'];
				$h->os = $res[$id_host]['os'];
				
				return $h;
			}
		}
		
		return False;
	}
	
	function insert()
	{
		global $_db, $_project;
		
		$this->id_project = intval($this->id_project);
		$this->id_domain = intval($this->id_domain);
		$this->name = mysql_real_escape_string($this->name);
		$this->ipaddr = mysql_real_escape_string($this->ipaddr);
		$this->os = mysql_real_escape_string($this->os);

		$vars = array('id_project' => $this->id_project,
			'id_domain' => $this->id_domain,
			'name' => $this->name,
			'ipaddr' => $this->ipaddr,
			'os' => $this->os);
		
		$this->id = $_db->insert_unique('hosts', $vars);

		return $this->id;
	}
	
	function load()
	{
		global $_db, $_project;
		
		$res = $_db->query('SELECT h.*, d.id AS id_domain, d.name AS domain_name, d.fqdn AS domain_fqdn
		FROM hosts h 
		LEFT JOIN domains d ON (h.id_domain = d.id)
		WHERE h.id='. $this->id .' AND h.id_project='. $_project->id);
		
		if ($res)
		{
			$this->id_project = $res[$this->id]['id_project'];
			$this->id_domain = $res[$this->id]['id_domain'];
			$this->name = $res[$this->id]['name'];
			$this->ipaddr = $res[$this->id]['ipaddr'];
			$this->os = $res[$this->id]['os'];
			
			$this->domain_id = $res[$this->id]['id_domain'];
			$this->domain_name = $res[$this->id]['domain_name'];
			$this->domain_fqdn = $res[$this->id]['domain_fqdn'];
		}
	}
	
	function loadRoles()
	{
		global $_db, $_project;
		
		$res = $_db->query("SELECT r.name FROM roles r, hostroles hr WHERE hr.id_host=$this->id AND r.id=hr.id_role");
		
		foreach ($res AS $r)
			$this->roles[] = $r['name'];
		
		return $res;
	}

	function loadAppUsers()
	{
		global $_db, $_project;
		
		$res = $_db->query("SELECT a.id, a.app, a.url, a.username, a.password FROM appusers a WHERE a.id_host=$this->id AND a.id_project=$_project->id");
		
		foreach ($res AS $a)
			$this->appusers[$a['id']] = array('app' => $a['app'], 'url' => $a['url'], 'username' => $a['username'], 'password' => $a['password']);
		
		return $res;
	}
}
?>
