<?php
class Role
{
	public $id;
	public $id_project;
	public $id_host;
	public $id_role;
	public $role;
	
	public function __construct($id = 0)
	{
		$id = intval($id);
		
		if ($id !== 0)
		{
			$this->id = $id;
			$this->load();
		}
		else return False;
	}
	
	public function listAll()
	{
		global $_db, $_project;
		
		return $_db->query('SELECT hr.*, r.name AS role FROM hostroles hr, roles r WHERE hr.id_project='. $_project->id .' AND hr.id_role=r.id ORDER BY r.role');
	}
	
	function insert()
	{
		global $_db, $_project;
		
		$this->id_project = intval($this->id_project);
		$this->id_host = intval($this->id_host);
		$this->id_role = intval($this->id_role);

		$this->id = $_db->insert_unique('hostroles', array(
			'id_project' => $_project->id,
			'id_host' => $this->id_host,
			'id_role' => $this->id_role)
		);
		
		return $this->id;
	}
	
	function getByName($name)
	{
		global $_db;
		
		$id = $_db->getid("SELECT id FROM roles WHERE name='$name'");
		
		if ($id)
			return $id;
		
		else
			return $_db->insert_unique('roles', array('name' => $name));
	}
	
	function getNameById($id)
	{
		global $_db;
		
		$id = intval($id);
		
		$res = $_db->query("SELECT name FROM roles WHERE id='$id' LIMIT 1");
		
		return (isset($res[0]['name']) ? $res[0]['name'] : False);
	}
	
	function load()
	{
		global $_db, $_project;
		
		$res = $_db->query('SELECT hr.*, r.name AS role FROM hostroles hr, roles r WHERE hr.id_project='. $_project->id .' AND hr.id='. $this->id .' AND hr.id_role=r.id LIMIT 1');
		
		if ($res)
		{
			$this->id_project = $res[$this->id]['id_project'];
			$this->id_host = $res[$this->id]['id_host'];
			$this->id_role = $res[$this->id]['id_role'];
			$this->role = $res[$this->id]['role'];
		}
	}
	
	function getByPort($proto, $number)
	{
		$roles = array('tcp' => array(
						80 => 'Web Server',
						443 => 'Web Server (SSL)',
						8080 => 'Web or Proxy Server',
						3128 => 'Socks Proxy',
						3306 => 'MySQL Database',
						1521 => 'Oracle Database',
						1433 => 'MSSQL Database',
						21 => 'FTP Server',
						22 => 'SSH Server',
						25 => 'SMTP Server',
						),
						'udp' => array(
						123 => 'NTP Server',
						53 => 'DNS Server',
						));
		
		return (isset($roles[$proto][$number]) ? $roles[$proto][$number] : False);
	}
}
?>
