<?php
class Tree
{
	public $id_project;
	public $hosts = array();
	public $roles = array();
	public $ports = array();
	public $domains = array();
	public $adusers = array();
	public $adgroups = array();

	private $list_hosts = Null;

	public function __construct($id_project = 0)
	{
		global $_db;
		$id_project = intval($id_project);

		if ($id_project !== 0)
		{
			$this->id_project = $id_project;
			$this->list_hosts = $_db->query('SELECT id, ipaddr FROM hosts WHERE id_project='. $this->id_project);
			return True;
		}
		else return False;
	}

	public function loadHosts()
	{
		global $_db;

		$res_ports = $_db->query('SELECT id, id_host, concat(number, "/", proto) AS port FROM ports WHERE id_project='. $this->id_project);
		foreach ($this->list_hosts as $id_host => $h)
		{
			$cidr = slash24($h['ipaddr']);
			$this->hosts[$cidr][$id_host .'|'. $h['ipaddr']] = array();
			foreach ($res_ports AS $id_port => $p)
			{
				if ($p['id_host'] == $id_host)
					$this->hosts[$cidr][$id_host .'|'. $h['ipaddr']][] = $p['port'];
			}
		}

		return True;
	}

	public function loadPorts()
	{
		global $_db;

		if (!count($this->list_hosts))
			return False;

		$res_ports = $_db->query('SELECT id, id_host, concat(number, "/", proto) AS port FROM ports WHERE id_project='. $this->id_project);
		foreach ($res_ports as $id_port => $p)
		{
			$id_host = $p['id_host'];
			if (isset($this->list_hosts[$id_host]))
			{
				$ipaddr = $this->list_hosts[$id_host]['ipaddr'];
				$subnet = slash24($ipaddr);
							
				if (!isset($this->ports[$p['port']][$subnet]))
					$this->ports[$p['port']][$subnet] = 1;
				else
					$this->ports[$p['port']][$subnet]++;
			}
		}

		return True;
	}

	public function loadRoles()
	{
		global $_db;

		$res_roles = $_db->query('SELECT hr.id, hr.id_host, hr.id_role, r.name FROM hostroles hr, roles r WHERE hr.id_role=r.id AND hr.id_project='. $this->id_project);
		foreach ($this->list_hosts as $id_host => $h)
		{
			foreach ($res_roles AS $id_role => $r)
			{
				if ($r['id_host'] == $id_host)
					$this->roles[$r['id_role'] .'|'. $r['name']][] = $id_host .'|'. $h['ipaddr'];
			}
		}

		return True;
	}

	public function loadDomains()
	{
		global $_db;

		$res_domains = $_db->query('SELECT id, name, fqdn, policy FROM domains WHERE id_project='. $this->id_project);

		foreach ($res_domains AS $id_domain => $d)
		{
			$name = $d['id'] .'|'. (empty($d['name']) ? $d['fqdn'] : $d['name'] .' ('. $d['fqdn'] .')');
			
			$users = $_db->query("SELECT COUNT(id) AS nb FROM users WHERE id_domain=$id_domain AND id_project=$this->id_project");
			$groups = $_db->query("SELECT COUNT(id) AS nb FROM groups WHERE id_domain=$id_domain AND id_project=$this->id_project");
			$hosts = $_db->query("SELECT COUNT(id) AS nb FROM hosts WHERE id_domain=$id_domain AND id_project=$this->id_project");
			$policy = $_db->query("SELECT COUNT(policy) AS nb FROM domains WHERE LENGTH(policy)>1 AND id=$id_domain AND id_project=$this->id_project");

			$this->domains[$name] = array('users' => $users[0]['nb'], 'groups' => $groups[0]['nb'], 'hosts' => $hosts[0]['nb'], 'policy' => $policy[0]['nb']);
		}

		return True;
	}
}
?>
