<?php
class Vuln
{
	public $id;
	public $id_project;
	public $id_host;
	public $port;
	public $descr;
	public $severity; /* 0: info, 1: low, 2: medium, 3: high, 4: critical */
	
	public function __construct($id = 0)
	{
		$id = intval($id);
		
		if ($id !== 0)
		{
			$this->id = $id;
			$this->load();
		}
		else return False;
	}
	
	public function listAll()
	{
		global $_db, $_project;
		
		return $_db->query('SELECT * FROM vulns WHERE id_project='. $_project->id .' ORDER BY severity');
	}
	
	public function listByHost($id_host)
	{
		global $_db, $_project;
		
		$ports = $_db->query('SELECT v.id, h.name AS hostname, h.ipaddr, v.port, v.severity, v.descr
			FROM vulns v LEFT JOIN hosts h ON (v.id_host = h.id) WHERE v.id_host='. intval($id_host) .' AND v.id_project='. $_project->id); 
		
		$ret = array();
		foreach ($vulns as $v)
			$ret[$v['id']][] = array('id' => $v['id'], 'ip' => $v['ipaddr'], 'hostname' => $v['hostname'], 'port' => $v['port'], 'severity' => $v['severity'], 'descr' => $v['descr']);

		return $ret;
	}

	function insert()
	{
		global $_db, $_project;
		
		$this->id_project = intval($this->id_project);
		$this->id_host = intval($this->id_host);
		$this->port = intval($this->port);
		$this->descr = mysql_real_escape_string($this->descr);
		$this->severity = intval($this->severity);

		$vars = array('id_project' => $this->id_project,
			'id_host' => $this->id_host,
			'port' => $this->port,
			'descr' => $this->descr,
			'severity' => $this->severity,
			);
		
		$this->id = $_db->insert_unique('vulns', $vars);

		return $this->id;
	}
	
	function load()
	{
		global $_db, $_project;
		
		$res = $_db->query('SELECT * FROM vulns WHERE id='. $this->id .' AND id_project='. $_project->id);
		if ($res)
		{
			$this->id_project = $res[$this->id]['id_project'];
			$this->id_host = $res[$this->id]['id_host'];
			$this->port = $res[$this->id]['port'];
			$this->descr = $res[$this->id]['descr'];
			$this->severity = $res[$this->id]['severity'];
		}
	}
}
?>
