<?php
if (isset($view) and $view == 'discover')
{
	if (isset($id) and $id == 'run')
	{
		$_hostconf = new Hostconf($_project->id);

		if ($_hostconf->loaded === False)
			$_hostconf->load();
		
		echo '<fieldset><legend>Discover Network</legend>';
		
		$subnet = substr(slash24($_hostconf->ip), 0, -3);
		
		$modules = array(
		
		'nicinfo' => null,       /* retrieve info from NIC config */
		
		'routesinfo' => null,    /* retrieve info from routing table */
		
		'dnssrvs' => null,       /* retrieve dns servers from /etc/resolv.conf */
		
		'pingsweep' => array(    /* subnet ping sweep */
			'target' => $subnet, /* specify target */
			'run' => 'auto'      /* run automatically */
			),
		
		'axfr' => array(         /* DNS zone transfer */
			'target' => 'all',   /* attempt zone transfer against all DNS srvs */
			'run' => 'auto',     /* and run automatically */
			'stop' => 1          /* and stop after first success */
			),
		
		'msdcs' => null,         /* retrieve MS DCs via DNS */
		
		'enum' => array(         /* NetBIOS anonymous enumeration */
			'target' => 'all',   /* run enum against all DNS and DCs */
			'run' => 'auto',     /* and run automatically */
			'stop' => 1          /* and stop after first success */
			),
		
		'sleep' => 5,            /* test module that sleeps X secs */
		);
		
		echo modules($modules);
		
		flush();
		//refreshtree();
		echo '</fieldset>';
	}
	else
	{
		echo '<fieldset><legend>Discover Network</legend>
			<p>This module uses the following information to initially populate the database:<p>
			<p><ul>
			<li>NIC information</li>
			<li>Routing table</li>
			<li>DNS servers</li>
			<li>Search domains</li>
			<li>Domain Controllers</li>
			<li>Anonymous NetBIOS enum against DCs</li>
			<li>DNS zones transfers</li>
			<li>Resolution of DNS suffixes</li>
			<li>Ping sweep of local subnet</li>
			</ul></p>
			<p><a href="/view/discover/run">Run tests...</a></p>
		</fieldset>';
	}
}
?>
