<?php
function display_domain($d, $class)
{
	return '<tr align="center" class="'. $class .'">
	  <td><span class="domain">'. $d['name'] .'</span></td>
	  <td><span class="domain">'. $d['fqdn'] .'</span></td>
	  <td>'. (empty($d['policy']) ? 'No' : 'Yes') .'</td>
	  <td>'. (!$d['enumered'] == 0 ? 'No' : 'Yes') .'</td>
	  <td>'. (!$d['axfred'] ? 'No' : 'Yes') .'</td>
	</tr>'."\n";
}

function display_group($g, $class)
{
	return '<tr align="center" class="'. $class .'">
	  <td align="left"><span class="group"><a href="/view/group/'. $g['id'] .'">'. $g['name'] .'</a></span></td>
	  <td>'. $g['nb'] .'</td>
	  <td>'. $g['rid'] .'</td>
	</tr>'."\n";
}

function display_user($u, $class)
{
	return '<tr align="center" class="'. $class .'">
	  <td align="left"><span class="user"><a href="/view/user/'. $u['id'] .'">'. $u['name'] .'</a></span></td>
	  <td>'. $u['fullname'] .'</td>
	  <td>'. $u['rid'] .'</td>
	  <td>'. $u['descr'] .'</td>
	  <td>'. $u['pwd'] .'</td>
	</tr>'."\n";
}

function display_host($h, $class)
{
	return '<tr class="'. $class .'">
	<td><span class="host"><a href="/view/host/'. $h['id'] .'">'. (!empty($h['name']) ? $h['name'] : $h['ipaddr']) .'</a></span></td>
	<td align="center">'. $h['ipaddr'] .'</td>'."</tr>\n";
}

if (isset($view) and $view == 'domain')
{
	if (!empty($id))
	{
		$id = intval($id);
		$d = new Domain($id);

		if (!empty($d->fqdn))
		{
			if (!empty($type))
			{
				$cpt = 0;

				if ($type == 'hosts') // View hosts in domain
				{
					$list = $d->listHosts();

					echo '<fieldset><legend>Hosts in domain: '. $d->fqdn .' ('. count($list) .')</legend>';

					if (!count($list))
						echo '<span class="err">No hosts in database</span>';
					else
					{
						echo '<table cellspacing="0">
						<tr class="trhdr">
						  <td class="tdhdr" width="150">Hostname</td>
						  <td class="tdhdr" width="150" align="center">IP Address</td>
						</tr>'."\n";

						foreach ($list AS $id_host => $h)
							echo display_host($h, (($cpt++ % 2) ? 'tdrow2' : 'tdrow1'));

						echo '</table>';
					}
					echo '</fieldset>';
				}

				elseif ($type == 'groups') // View groups in domain
				{
					$list = $d->listGroups();

					echo '<fieldset><legend>Groups in domain: '. $d->fqdn .' ('. count($list) .')</legend>';

					if (!count($list))
						echo '<span class="err">No groups in database</span>';
					else
					{
						echo '<table cellspacing="0">
						<tr class="trhdr">
						  <td class="tdhdr" width="100">Group Name</td>
						  <td class="tdhdr" width="90" align="center">Users in group</td>
						  <td class="tdhdr" width="90" align="center">Group RID</td>
						</tr>'."\n";

						foreach ($list AS $id => $g)
							echo display_group($g, (($cpt++ % 2) ? 'tdrow2' : 'tdrow1'));

						echo '</table>';
					}
					echo '</fieldset>';
				}

				elseif ($type == 'users') // View users in domain
				{
					$list = $d->listUsers();

					echo '<fieldset><legend>Users in domain: '. $d->fqdn .' ('. count($list) .')</legend>';

					if (!count($list))
						echo '<span class="err">No users in database</span>';
					else
					{
						echo '<table cellspacing="0">
						<tr class="trhdr">
						  <td class="tdhdr" width="150" align="center">Username</td>
						  <td class="tdhdr" width="150" align="center">Full Name</td>
						  <td class="tdhdr" width="150" align="center">UID</td>
						  <td class="tdhdr" width="200" align="center">Description</td>
						  <td class="tdhdr" width="200" align="center">Password</td>
						</tr>'."\n";

						foreach ($list AS $id_user => $u)
							echo display_user($u, (($cpt++ % 2) ? 'tdrow2' : 'tdrow1'));

						echo '</table>';
					}
					echo '</fieldset>';
				}

				elseif ($type == 'policy') // View domain policy
				{
					$modules = array('policy' => array('target' => 'all'));

					echo '<fieldset><legend>Policy of domain: '. $d->fqdn .'</legend>';

					if (!empty($d->policy))
						echo modules($modules);

					$modules['policy']['aff'] = 'res';
					$d->policy = stripslashes($d->policy);
					$policy = !empty($d->policy) ? $d->policy : modules($modules);

					echo '<table cellspacing="0">
					<tr class="trhdr">
					  <td class="tdhdr" align="center" width="500">Policy</td>
					</tr>
					<tr>
					  <td'. (empty($d->policy) ? ' style="padding-top: 6px;"' : '') .'>'. $policy .'</td>
					</tr>
					</table></fieldset>'."\n";
				}
			}
			else  // View 1 domain
			{
				echo '<fieldset><legend>Domain: '. $d->fqdn .'</legend>
				<table cellspacing="0">
				<tr class="trhdr">
				  <td class="tdhdr" width="150" align="center">Domain Name</td>
				  <td class="tdhdr" width="150" align="center">Domain FQDN</td>
				  <td class="tdhdr" width="200" align="center">Policy retrieved</td>
				  <td class="tdhdr" width="200" align="center">NetBIOS Enumeration done</td>
				  <td class="tdhdr" width="200" align="center">Zone Transfers done</td>
				</tr>
				'. display_domain((array) $d, 'tdrow2') .'
				</table></fieldset>'."\n";
			}
		}
		else echo '<span class="err">No host found.</span>';
	}
	
	else // View all domains
	{
		$cpt = 0;
		$domains = Domain::getFqdns();
		foreach ($domains AS $d)
		{
			echo '<fieldset><legend>Domain: '. $d['fqdn'] .'</legend>
			<table cellspacing="0">
			<tr class="trhdr">
			  <td class="tdhdr" width="150" align="center">Domain Name</td>
			  <td class="tdhdr" width="150" align="center">Domain FQDN</td>
			  <td class="tdhdr" width="200" align="center">Policy retrieved</td>
			  <td class="tdhdr" width="200" align="center">NetBIOS Enumeration done</td>
			  <td class="tdhdr" width="200" align="center">Zone Transfers done</td>
			</tr>
			'. display_domain($d, (($cpt++ % 2) ? 'tdrow2' : 'tdrow1')) .'
			</table></fieldset>'."\n";
		}
	}
}
?>
