<?php
function display_host($h, $class)
{
	if (!empty($h['domain_name']))
		$h['domain_fdqn'] = $h['domain_name'] .' ('. $h['domain_fqdn'] .')';
	
	return '<tr class="'. $class .'">
	<td><span class="host"><a href="/view/host/'. $h['id'] .'">'. (!empty($h['name']) ? $h['name'] : $h['ipaddr']) .'</a></span></td>
	<td align="center">'. $h['ipaddr'] .'</td>
	<td align="center">'. $h['domain_fqdn'] .'</span></td></tr>'."\n";
}

function display_subnet($subnet, $hosts_arr)
{
	$cpt = 0;
	$ret = '<fieldset><legend>Subnet: '. $subnet .'</legend>';
	
	$modules = array(
		'pingsweep' => array('target' => substr($subnet, 0, -3)), 
		'portscan' => substr($subnet, 0, -3)
	);
		
	$ret .= modules($modules);
	
	$ret .= '<table cellspacing="0"><tr class="trhdr">
	<td class="tdhdr" width="150">Hostname</td>
	<td class="tdhdr" width="150" align="center">IP Address</td>
	<td class="tdhdr" width="200" align="center">Member of domain</td></tr>'."\n";
	
	foreach ($hosts_arr AS $h)
		$ret .= display_host($h, (($cpt++ % 2) ? 'tdrow2' : 'tdrow1'));
		
	$ret .= '</table>';
	$ret .= '</fieldset>';
	
	return $ret;
}

if (isset($view) and $view == 'host')
{
	if (isset($id) and !is_ip($id)) // View 1 host
	{
		$id = intval($id);
		$h = new Host($id);
		
		if (!empty($h->ipaddr))
		{
			echo '<fieldset><legend>Host: '. $h->ipaddr .'</legend>';
			
			$modules = array('portscan' => $h->ipaddr);
			
			$h->loadRoles();
			$h->loadAppUsers();
			
			foreach ($h->roles AS $r)
				foreach (modules_by_role($r) AS $mod_name)
					$modules[$mod_name] = array('target' => $h->ipaddr, 'role' => Role::getByName($r));

			foreach ($h->appusers AS $usr_arr)
				foreach (modules_by_app($usr_arr['app']) AS $mod_name)
					$modules[$mod_name] = array('target' => $h->ipaddr);

			echo modules($modules);

			echo '<table cellspacing="0"><tr class="trhdr">
			<td class="tdhdr" width="150">Hostname</td>
			<td class="tdhdr" width="150" align="center">IP Address</td>
			<td class="tdhdr" width="200" align="center">Member of domain</td></tr>
			'. display_host((array) $h, 'tdrow2') .'
			</table></fieldset>'."\n";
		}
		else echo '<span class="err">No host found.</span>';
	}

	if (isset($id) and is_ip($id)) // View 1 subnet
	{
		$subnet_id = $id;
		$list = Host::listBySubnet();
		
		foreach ($list AS $subnet => $hosts_arr)
			if ($subnet_id == substr($subnet, 0, strpos($subnet, '/')))
				echo display_subnet($subnet, $hosts_arr);
	}

	elseif (!isset($id)) // View all hosts
	{
		$list = Host::listBySubnet();
		
		foreach ($list AS $subnet => $hosts_arr)
			echo display_subnet($subnet, $hosts_arr);
	}
}
?>
