<?php
function build_tree(&$tree)
{
	$n = "\n";
	$ret = '<ul>'. $n;

	// start hosts
	$ret .= '  <li id="hosts"><a href="#" onclick="loadurl(\'/view/host\')">Subnets</a>'. $n;
	$ret .= '    <ul>'. $n;
	foreach ($tree->hosts AS $subnet => $hosts_arr)
		$ret .= '      <li rel="subnet"><a href="#" onclick="loadurl(\'/view/host/'. substr($subnet, 0, -3) .'\')">'. $subnet .' ('. count($hosts_arr) .')</a></li>'. $n;
	$ret .= '    </ul>'. $n;
	$ret .= '  </li>'. $n;
	// end hosts

	// start ports
	$ret .= '  <li id="ports"><a href="#" onclick="loadurl(\'/view/port\')">Ports</a>'. $n;
	$ret .= '    <ul>'. $n;
	foreach ($tree->ports AS $port => $nets_arr) {
		$ret .= '      <li rel="port"><a href="#" onclick="loadurl(\'/view/port/'. 
		urlencode(str_replace('/', '_', $port)) .'\')">'. $port .'</a>'. $n;
		$ret .= '        <ul>'. $n;
		foreach ($nets_arr AS $subnet => $count) {
			$ret .= '          <li rel="subnet"><a href="#" onclick="loadurl(\'/view/port/'. 
			urlencode(str_replace('/', '_', $port)) .'/'. substr($subnet, 0, -3) .'\')">'. 
			$subnet .' ('. $count .')</a></li>'. $n;
		}
		$ret .= '        </ul>'. $n;
		$ret .= '      </li>'. $n;
	}
	$ret .= '    </ul>'. $n;
	$ret .= '  </li>'. $n;
	// end ports

	// start roles
	$ret .= '  <li><a id="roles" href="#" onclick="loadurl(\'/view/role\')">Roles</a>'. $n;
	$ret .= '    <ul>'. $n;
	foreach ($tree->roles AS $role => $hosts_arr) {
		$role = explode('|', $role);
		$ret .= '      <li rel="role"><a href="#" onclick="loadurl(\'/view/role/'. $role[0] .'\')">'. $role[1] .' ('. count($hosts_arr) .')</a>'. $n;
		$ret .= '        <ul>'. $n;
		foreach ($hosts_arr AS $host) {
			$host = explode('|', $host);
			$ret .= '          <li rel="host"><a href="#" onclick="loadurl(\'/view/host/'. $host[0] .'\')">'. $host[1] .'</a></li>'. $n;
		}
		$ret .= '        </ul>'. $n;
		$ret .= '      </li>'. $n;
	}
	$ret .= '    </ul>'. $n;
	$ret .= '  </li>'. $n;
	// end roles

	// start domains
	$ret .= '  <li id="domains"><a href="#" onclick="loadurl(\'/view/domain\')">Domains</a>'. $n;
	$ret .= '    <ul>'. $n;
	foreach ($tree->domains AS $id_domain => $domain) {
		$id_domain = explode('|', $id_domain);
		$ret .= '      <li rel="domain"><a href="#" onclick="loadurl(\'/view/domain/'. $id_domain[0] .'\')">'. $id_domain[1] .'</a>'. $n;
		$ret .= '        <ul>'. $n;
		$ret .= '            <li><a href="#" onclick="loadurl(\'/view/domain/'. $id_domain[0] .'/hosts\')">Hosts ('. $domain['hosts'] .')</a></li>'. $n; // hosts
		$ret .= '            <li><a href="#" onclick="loadurl(\'/view/domain/'. $id_domain[0] .'/groups\')">Groups ('. $domain['groups'] .')</a></li>'. $n; // groups
		$ret .= '            <li><a href="#" onclick="loadurl(\'/view/domain/'. $id_domain[0] .'/users\')">Users ('. $domain['users'] .')</a></li>'. $n; // users
		$ret .= '            <li><a href="#" onclick="loadurl(\'/view/domain/'. $id_domain[0] .'/policy\')">Policy ('. $domain['policy'] .')</a></li>'. $n; // policy
		$ret .= '        </ul>'. $n;
		$ret .= '      </li>'. $n;

	}
	$ret .= '    </ul>'. $n;
	$ret .= '  </li>'. $n;
	// end domains

	$ret .= '</ul>'. $n;

	return $ret;
}
?>
