<?php
function link_axfr($arr)
{
	if (isset($arr['target']))
	{
		if (isset($arr['run']) and $arr['run'] == 'auto')
		{
			return "<script>MakeCmdRequest('cmd_axfr". $arr['target'] ."', 'axfr', '". http_build_query($arr) ."', true);</script>".
			'<div class="cmd_line" id="cmd_axfr'. $arr['target'] .'"><span class="wait">Attempting zone transfers on DNS suffixes ...</span></div>';
		}
		else
		{
			return '<p id="cmd_axfr_'. $arr['target'] .'">'.
			"<a href=\"#\" onclick=\"this.className='wait';
			MakeCmdRequest('cmd_axfr_". $arr['target'] ."', 'axfr', '". http_build_query($arr) ."', true);
			return false;\">Attempting zone transfers on DNS suffixes ...</a></p>";
		}
	}
}
function run_axfr()
{
	global $_project;
	
	if (!set_and_not_empty($_POST, 'target')) return;
	$target = filter_cmd($_POST['target']);
	
	$success = 0;
	
	if ($target == 'all') // run axfr against all DNS servers
	{
		foreach (Domain::getFqdns() AS $d)
		{
			$domain = new Domain($d['id']);
			$dns_srvs = $_project->getHostsByRole('DNS Server');
			
			foreach ($dns_srvs AS $id_host => $s)
			{
				$success = do_axfr($domain, $s['ipaddr']);
				
				if ($domain->axfred == 1 and (isset($_POST['stop']) AND $_POST['stop'] == 1)) // stop after first success
					break ;
			}
		}
		
		if ($success)
			echo '<span class="confirm">Zone transfer on '. count($dns_srvs) .' DNS servers returned '. $success .' hosts</span>';
	}
	
	elseif (is_ip($target)) // run axfr against one target
	{
		$domain = Domain::getByDnsIp($target);
		if ($domain)
			$success = do_axfr($domain, $target);
		
		if ($success)
			echo '<span class="confirm">Zone transfer on '. $target .' returned '. $success .' hosts</span>';
	}
	
	if (!$success)
		echo '<span class="err">Zone transfer attempts failed</span>';
}
function do_axfr($domain, $dns)
{
	global $_project;
	
	$cmd = new Cmd("dig -t axfr ". $domain->fqdn ." @". $dns);
	$output = $cmd->exec();
	$cpt = 0;

	foreach ($output AS $line)
	{
		$tab = explode(' ', strip_sp($line));
		if (isset($tab[7]) AND $tab[3] == "SRV")
		{
			$hostname = trim($tab[7]);
			$ip = gethostbyname($hostname);
			
			if (is_ip($ip))
			{
				$h = new Host();
				$h->id_project = $_project->id;
				$h->id_domain = intval($domain->id);
				$h->name = $hostname;
				$h->ipaddr = $ip;
				if ($h->insert()) $cpt++;
			}
		}

		if (isset($tab[4]) AND $tab[3] == "A")
		{
			$hostname = substrt($tab[0], '.');
			$ip = trim($tab[4]);

			if (is_ip($ip))
			{
				$h = new Host();
				$h->id_project = $_project->id;
				$h->id_domain = intval($domain->id);
				$h->name = $hostname;
				$h->ipaddr = $ip;
				if ($h->insert()) $cpt++;
			}
		}
	}
	
	if ($cpt > 1)
	{
		$domain->axfred = 1;
		$domain->update();
	}
	
	return $cpt;
}
?>
