<?php
function link_dnssrvs()
{
	return "<script>MakeCmdRequest('cmd_dnssrvs', 'dnssrvs', '', false);</script>".
	'<div class="cmd_line" id="cmd_dnssrvs"><span class="wait">Retreiving DNS servers & domains FQDNs...</span></div>';
}
function run_dnssrvs()
{
	global $_project;

	$local_subnets = array();
	$_hostconf = new Hostconf($_project->id);

	if ($_hostconf->loaded === False)
		$_hostconf->load();
	
	$cpt = array(0, 0, 0);
	foreach (explode("\n", $_hostconf->resolv) AS $r)
	{
		$tab = explode(' ', $r);
		if (isset($tab[0]) and $tab[0] == 'nameserver')
		{
			$resolv = gethostbyaddr($tab[1]);

			$ns = new Host();
			$ns->id_project = $_project->id;
			$ns->name = ($resolv ? $resolv : '?');
			$ns->ipaddr = $tab[1];
			if ($ns->insert())
			{
				$cpt[0]++;

				$role = new Role();
				$role->id_project = $_project->id;
				$role->id_host = $ns->id;
				$role->id_role = Role::getByName('DNS Server');
				if ($role->insert()) $cpt[1]++;
			}
			$local_subnets[slash24($tab[1])] = 1;
		}
		
		if (isset($tab[0]) and $tab[0] == 'domain')
		{
			$d = new Domain();
			$d->id_project = $_project->id;
			$d->name = '';
			$d->fqdn = $tab[1];
			$d->policy = $d->getPolicy();
			if ($d->insert()) $cpt[2]++;
		}
	}
	echo '<span class="confirm">Analysis of /etc/resolv.conf returned '. $cpt[0] .' DNS server'. ($cpt[0] > 1 ? 's' : '') .', '. 
	$cpt[1] .' role'. ($cpt[1] > 1 ? 's' : '') .', '. 
	$cpt[2] .' domain'. ($cpt[2] > 1 ? 's' : '') .' and '. 
	count($local_subnets) .' subnet'. (count($local_subnets) > 1 ? 's' : '') .'</span>';
}
?>
