<?php
function link_dnssuffixes()
{
	return "<script>MakeCmdRequest('cmd_dnssuffixes', 'dnssuffixes', '', false);</script>".
	'<div class="cmd_line" id="cmd_dnssuffixes"><span class="wait">Resolving DNS suffixes ...</span></div>';
}
function run_dnssuffixes()
{
	global $_project;

	$local_subnets = array();
	$cpt = array(0, 0);
	foreach (Domain::getFqdns() AS $d)
	{
		$cmd = new Cmd("host ". $d['fqdn']);
		$output = $cmd->exec();

		foreach ($output AS $line)
		{
			$line = strip_sp($line);
			if (strpos($line, 'has address'))
			{
				$tab = explode(' ', $line);
				$ip = trim($tab[3]);
				if (is_ip($ip))
				{
					$h = new Host();
					$h->id_project = $_project->id;
					$h->id_domain = intval($d['id']);
					$h->name = '';
					$h->ipaddr = $ip;
					if ($h->insert())
					{
						$cpt[0]++;

						$role = new Role();
						$role->id_project = $_project->id;
						$role->id_host = $h->id;
						$role->id_role = Role::getByName('DNS Server');
						if ($role->insert()) $cpt[1]++;
					}

					$local_subnets[slash24($ip)] = 1;
				}
			}
		}
	}
	echo '<span class="confirm">Resolutions on DNS suffixes returned '. $cpt[0] .' host'. ($cpt[0] > 1 ? 's' : '') .', '. 
	$cpt[1] .' role'. ($cpt[1] > 1 ? 's' : '') .' and '. 
	count($local_subnets) .' subnet'. (count($local_subnets) > 1 ? 's' : '') .'</span>';
}
?>
