<?php
function link_enum($arr)
{
	if (isset($arr['target']))
	{
		if (isset($arr['run']) and $arr['run'] == 'auto')
		{
			return "<script>MakeCmdRequest('cmd_enum". $arr['target'] ."', 'enum', '". http_build_query($arr) ."', true);</script>".
			'<div class="cmd_line" id="cmd_enum'. $arr['target'] .'"><span class="wait">Enumerating info via NetBIOS ...</span></div>';
		}
		else
		{
			return '<p id="cmd_enum_'. $arr['target'] .'">'.
			"<a href=\"#\" onclick=\"this.className='wait';
			MakeCmdRequest('cmd_enum_". $arr['target'] ."', 'enum', '". http_build_query($arr) ."', true);
			return false;\">Enumerating info via NetBIOS ...</a></p>";
		}
	}
}
function run_enum()
{
	global $_project;

	if (!set_and_not_empty($_POST, 'target')) return;
	$target = filter_cmd($_POST['target']);

	$success = 0;

	if ($target == 'all') // run enum on all DNS and DCs
	{
		$dest = array_merge($_project->getHostsByRole('Domain Controller'),
				$_project->getHostsByRole('DNS Server'));

		foreach ($dest AS $n => $host)
		{
			$h = new Host($host['id']);
			if ($h->id_domain)
			{
				$d = new Domain($h->id_domain);
				$success = do_enum($h, $d);

				if ($d->enumered == 1 and isset($_POST['stop'])) // stop after first success
					break ;
			}
		}

		if ($success)
			echo '<span class="confirm">NetBIOS enumeration on '. count($dest) .' servers returned '. $success['users'] .' users and '. $success['groups'] .' groups</span>';
	}

	elseif (is_ip($target)) // run enum against target
	{
		$host = Host::getByIp($target);
		if ($host instanceof Host)
			$success = do_enum($host, $domain);

		if ($success)
			echo '<span class="confirm">NetBIOS enumeration on '. $host->ipaddr .' returned '. $success['users'] .' users and '. $success['groups'] .' groups</span>';
	}

	if (!$success)
		echo '<span class="err">NetBIOS enumeration attempts failed</span>';
}

function do_enum($host, $domain)
{
	global $_project;

	$cmd = new Cmd("perl /opt/pl/enum4linux.pl -UG $host->ipaddr");
	$output = $cmd->exec();
	$users = $groups = array();
	$what = 0;

	foreach ($output AS $line)
	{
		$line = utf8_decode($line);
		$line = strip_sp($line);

		if (substr($line, 0, 13) == 'Domain Name: ')
		{
			$domain->name = trim(substr($line, 13));
			$domain->update();
		}

		if (startswith($line, '[+] Getting domain groups:'))
			$what = 1;

		if (startswith($line, '[+] Getting domain group memberships:'))
			$what = 2;

		/* Domain Users */
		if (substr($line, 0, 9) == 'index: 0x' AND $what == 0)
		{
			$words = array('index', 'RID', 'acb', 'Account', 'Name', 'Desc');
			$line = str_ireplace($words, '', $line);
			$fields = explode(':', $line);
			$fields = array_map('trim', $fields);

			$users[$fields[4]] = array(
				'rid' => hexdec($fields[2]),
				'name' => $fields[4],
				'fullname' => $fields[5],
				'descr' => $fields[6]
			);
		}

		/* Domain Groups */
		if (substr($line, 0, 7) == 'group:[' AND $what == 1)
		{
			$grp = substrft($line, 'group:[', ']');
			$rid = hexdec(substrf($line, 'rid:[', ']'));
			$groups[$rid]['name'] = $grp;
			$groups[$rid]['members'] = array();
		}


		/* Domain Group Memberships */
		if (substr($line, 0, 7) == 'Group \'' AND $what == 2)
		{
			$grp = substrft($line, '\'', '\'');
			$rid = substrft($line, '(RID: ', ')');
			$dom = substrft($line, 'member: ', '\\');
			$usr = substrf($line, '\\');

			if (isset($users[$usr]) AND isset($groups[$rid]))
				$groups[$rid]['members'][] = $users[$usr]['rid'];
		}
	}

	/* Insert users in base */
	foreach ($users AS $name => $usr)
	{
		$u = new User();
		$u->id_project = $_project->id;
		$u->id_domain = $domain->id;
		$u->rid = $usr['rid'];
		$u->name = $usr['name'];
		$u->fullname = $usr['fullname'];
		$u->descr = $usr['descr'];
		$u->insert();
	}

	/* Insert groups and groups memberships in base */
	foreach ($groups AS $rid => $grp)
	{
		$g = new Group();
		$g->id_project = $_project->id;
		$g->id_domain = $domain->id;
		$g->rid = $rid;
		$g->name = $grp['name'];
		$g->insert();

		foreach ($grp['members'] AS $uid)
			$g->addUserByUid($uid);
	}

	if (count($users) > 1 AND count($groups) > 1)
	{
		$domain->enumered = 1;
		$domain->update();

		return array('users' => count($users), 'groups' => count($groups));
	}

	return False;
}
?>
