<?php
if (isset($view) and isset($id) and $view != 'cmd')
{
	echo '<fieldset>';
	if (isset($_POST['submit']))
	{
		echo '<legend>Running command</legend>';
		echo "<script>MakeCmdRequest('cmd_run', '". $view ."', '". http_build_query($_POST) ."', true);</script>";
		echo '<div class="cmd_line" id="cmd_run"><span class="wait">Enumerating HTTP dirs/files of target(s)...</span></div>';
	}
	else echo form_httpenum(filter_cmd($id));
	echo '</fieldset>';
}

function link_httpenum($target)
{
	$id = 0;

	if (is_array($target) AND isset($target['target']))
	{
		$id = intval($target['role']);
		$target = $target['target'];
	}
	
	return "<p id=\"cmd_httpenum_". $target ."_". $id ."\"><a href=\"/view/httpenum/". $target ."_". $id ."\">Find dirs / files on ". (is_ip($target) ? $target : 'these servers') ."</a></p>";
}

function run_httpenum()
{
	global $_project;
	p($_POST);
	
	if (!set_and_not_empty($_POST, array('target', 'dict')))
		return;
	
	$urls = array();
	$dict_file = '/opt/dicts/'. basename($_POST['dict']);
	
	if (!file_exists($dict_file))
		die('<span class="err">File does not exist</span>');

	list($target, $id_role) = explode('_', $_POST['target']);
	$target = filter_cmd($target);
	$id_role = intval($id_role);
	$role_name = Role::getNameById($id_role);
	
	$http_roles = array('Web Server' => array('http', 80),
						'Web Server (SSL)' => array('https', 443),
						'Web or Proxy Server' => array('http', 8080));
	
	if ($target == 'all')
	{
		foreach ($_project->getHostsByRole($role_name) AS $id_host => $h)
			$urls = array_merge($urls, do_httpenum($h['ipaddr'], $id_host, $dict_file, $http_roles[$role_name]));

		if (count($urls))
			echo '<span class="confirm">HTTP enum returned URLs on '. count($urls) .' hosts</span>';
		else
			echo '<span class="err">HTTP enum did not return any URL</span>';
	}
	
	elseif (is_ip($target))
	{
		$host = Host::getByIp($target);
		if (isset($host->id) AND $host->id > 0)
		{
			$host->loadRoles();
			if (in_array($role_name, $host->roles))
				$urls = array_merge($urls, do_httpenum($host->ipaddr, $host->id, $dict_file, $http_roles[$role_name]));

			if (count($urls))
				echo '<span class="confirm">HTTP enum on '. $target .' returned '. count($urls[0]) .' URL(s)</span>';
			else
				echo '<span class="err">HTTP enum on '. $target .' did not return any URL</span>';		
		}
		else echo '<span class="err">Specified host does not exist in database</span>';
	}
}

function do_httpenum($target, $id_host, $dict_file, $params)
{
	global $_project;
	
	if (!is_ip($target))
		return False;
/*
 * http://10.1.1.51:8080/html:
Le fichier distant n'existe pas -- lien mort!!!
  HTTP/1.1 302 D\351plac\351 Temporairement
  Server: Apache-Coyote/1.1
  Location: http://10.1.1.51:8080/manager/
  Date: Wed, 07 Mar 2012 17:14:36 GMT
  Connection: keep-alive
  HTTP/1.1 404 Introuvable
  Server: Apache-Coyote/1.1
  Content-Type: text/html;charset=utf-8
  Content-Length: 987
  Date: Wed, 07 Mar 2012 17:14:36 GMT
  Connection: keep-alive
http://10.1.1.51:8080/manager/:
Le fichier distant n'existe pas -- lien mort!!!
  HTTP/1.1 401 Non-Autoris\351
  Server: Apache-Coyote/1.1
  Pragma: No-cache
  Cache-Control: no-cache
  Expires: Thu, 01 Jan 1970 01:00:00 CET
  WWW-Authenticate: Basic realm="Tomcat Manager Application"
  Content-Type: text/html;charset=utf-8
  Content-Length: 965
  Date: Wed, 07 Mar 2012 17:14:36 GMT
  Connection: keep-alive
ÉCHEC d'autorisation.
  HTTP/1.1 404 Introuvable
*/

	$base_url = $params[0] .'://'. $target .':'. $params[1] .'/';
	
	$cmd = new Cmd("wget -O /dev/null --max-redirect 0 --spider -S ". 
		($params[0] == 'https' ? '--no-check-certificate' : '')
		." -i $dict_file -B $base_url");

	$output = $cmd->exec();
	
	$ret = array();
	
	for ($i = 0; $i < count($output); $i++)
	{
		if (strpos($output[$i], 'Location: ') !== False and !strpos($output[$i], '[following]'))
		{
			$tab = explode(' ', $output[$i]);
			$url['code'] = 302;
			$url['url'] = $tab[1];
			$url['base'] = $base_url;
			$ret[$id_host][] = $url;
		}
		if (strpos($output[$i], ' 200 OK') !== False AND strpos($output[$i], 'URL: '))
		{
			$tab = explode(' ', $output[$i]);
			$url['code'] = 200;
			$url['url'] = $tab[3];
			$url['base'] = $base_url;
			$ret[$id_host][] = $url;
		}
		if (strpos($output[$i], ' 401 '))
		{
			$tab = explode(' ', $output[$i -3]);
			$url['code'] = 401;
			$url['url'] = $tab[3];
			$url['base'] = $base_url;
			
			while (substr($output[$i], 0, 18) != 'WWW-Authenticate: ')
			{
				$i++;
				if ($output[$i] == 'Authorization failed.')
					break ;
			}
			
			if (substr($output[$i], 0, 18) == 'WWW-Authenticate: ')
				$url['info'] = $output[$i];

			$ret[$id_host][] = $url;
		}
	}
	p($ret);
	// Create urls in base;

	return $ret;
}

function form_httpenum($target)
{
	$dicts = scandir('/opt/dicts');
	$tab = explode('_', $target);

	if ($tab[1] > 0)
	{
		if ($tab[0] == 'all') $tab[0] = 'All servers with role ';
		$tab[1] = Role::getNameById($tab[1]);
	}
	
	$ret = hdr() . '<legend>Enumerate HTTP dirs/files</legend>
	<form action="" method="POST">
	<table cellspacing="0">
	<tr class="trhdr"><td colspan="4">Attack configuration: '. $tab[0] .' "'. $tab[1] .'"</td></tr>
	<tr class="tdrow2">
	  <td class="bold" width="100">Dictionary:</td>
	  <td width="100">
		<select name="dict">';
	foreach ($dicts AS $file)
	{
		if (is_file('/opt/dicts/'. $file))
			$ret .= "<option value=\"$file\">$file</option>\n";
	}
	$ret .='  </select>
	    <input type="hidden" name="target" value="'. $target .'" />
	  </td>
	  <td><a href="/view/config/dicts">Manage dictionaries...</a></td>
	  <td><input type="submit" name="submit" value="Run attack ..." /></td>
	</tr>
	</table>
	</form>';
	
	return $ret;
}
?>
