<?php
if (isset($view) and isset($id) and $view != 'cmd')
{
	echo '<fieldset>';
	if (isset($_POST['submit']))
	{
		echo '<legend>Running command</legend>';
		echo "<script>MakeCmdRequest('cmd_run', '". $view ."', '". http_build_query($_POST) ."', true);</script>";
		echo '<div class="cmd_line" id="cmd_run"><span class="wait">Scanning ports of '. strip_tags($_POST['target']) .'</span></div>';
	}
	else echo form_portscan(filter_cmd($id));
	echo '</fieldset>';
}

function link_portscan($target)
{
	return "<p id=\"cmd_portscan_$target\"><a href=\"/view/portscan/$target\">Port scan</a></p>";
}

function run_portscan()
{
	global $_project;
	
	if (!set_and_not_empty($_POST, array('target', 'proto', 'mode', 'ports', 'sv', 'p0')))
		return;
	
	$cpt = 0;
	$scan = array('proto' => '', 'mode' => '', 'ports' => '', 'sv' => '', 'p0' => '');
	
	$target = filter_cmd($_POST['target']);
	$tab = explode('/', $target);
	if (is_ip($tab[0]))
	{
		if ($_POST['proto'] == 'udp')
			$scan['proto'] = '-sU';
		
		if ($_POST['proto'] == 'tcp' and $_POST['mode'] == 'syn')
			$scan['mode'] = '-sS';
			
		if ($_POST['proto'] == 'tcp' and $_POST['mode'] == 'connect')
			$scan['mode'] = '-sT';
			
		if ($_POST['sv'] == 'yes')
			$scan['sv'] = '-sV';

		if ($_POST['p0'] == 'no')
			$scan['p0'] = '-P0';

		$ports = explode('_', $_POST['ports']);
		if (!set_and_not_empty($ports, array(1)) or !is_numeric($ports[1]))
			$ports[1] = 1000;
		$scan['ports'] = '--top-ports='. intval($ports[1]);

		$cmd = new Cmd('/usr/bin/sudo /usr/bin/nmap -vv -n '. 
			$scan['proto'] .' '. 
			$scan['mode'] .' '. 
			$scan['sv'] .' '. 
			$scan['p0'] .' '. 
			$scan['ports'] .' '. 
			$target);
		
		$output = $cmd->exec();
		$hosts = array();
		
		foreach ($output AS $line)
		{
			if (strpos($line, 'Discovered open port ') !== false)
			{
				$tab = explode(' ', strip_sp($line));
				
				if (is_ip($tab[5]))
					$ip = $tab[5];
				else
					continue;
				
				$host = Host::getByIp($ip);

				if ($host)
				{
					$hosts[$host->id] = 1;
					$port = explode('/', $tab[3]);
					
					$p = new Port();
					$p->id_project = $_project->id;
					$p->id_host = $host->id;
					$p->proto = $port[1];
					$p->number = intval($port[0]);
					$p->insert();
					$cpt++;

					if ($p->id_host and Role::getByPort($p->proto, $p->number))
					{
						$name = Role::getByPort($p->proto, $p->number);
						
						$r = new Role();
						$r->id_project = $_project->id;
						$r->id_host = $host->id;
						$r->id_role = Role::getByName($name);
						$r->insert();
					}
				}
			}
		}
	}

	echo '<span class="confirm">Port scan on '. $target .' returned '. $cpt .' port'. ($cpt > 1 ? 's' : '') .
		' on '. count($hosts) .' host'. (count($hosts) > 1 ? 's' : '') .'</span>';
}

function form_portscan($target)
{
	$tab = explode('.', $target);
	$byte = array_pop($tab);
	
	if (intval($byte) == 0) // this is a subnet
		$target .= '/24';
	
	$ret = hdr() . '<legend>Port Scan</legend>
	<form action="" method="POST">
	<table cellspacing="0">
	<tr class="trhdr"><td colspan="6">Scan configuration: '. $target .'</td></tr>
	<tr class="tdrow2">
	  <td class="bold" width="100">Protocol:</td>
	  <td width="60">
		<select name="proto">
			<option value="tcp" selected="selected">TCP</option>
			<option value="udp">UDP</option>
		</select>
		</td>
	  <td class="bold" width="100">Mode&nbsp;(TCP&nbsp;only):</td>
	  <td width="110">
		<select name="mode">
			<option value="syn" selected="selected">SYN scan</option>
			<option value="connect">Connect scan</option>
		</select>
	  </td>
	  <td class="bold" width="70">Ports:</td>
	  <td width="130">
		<select name="ports">
			<option value="top_10">Top 10</option>
			<option value="top_100">Top 100</option>
			<option value="top_1000" selected="selected">Top 1000 (default)</option>
			<option value="top_2000">Top 2000</option>
			<option value="top_3000">Top 3000</option>
			<option value="top_65535">All ports</option>
		</select>
	  </td>
	</tr>
	<tr class="tdrow1">
	  <td class="bold" width="100">Ping&nbsp;before&nbsp;scan:</td>
	  <td width="60">
		<select name="p0">
			<option value="yes" selected="selected">Yes</option>
			<option value="no">No</option>
		</select>
	  </td>
	  <td class="bold">Service&nbsp;versions:</td>
	  <td width="90">
		<select name="sv">
			<option value="no" selected="selected">Don\'t scan</option>
			<option value="yes">Scan</option>
		</select>
	  </td>
	  <td colspan="2" align="center">
	    <input type="hidden" name="target" value="'. $target .'" />
	    <input type="submit" name="submit" value="Run scan ..." />
	  </td>
	</tr>
	</table>
	</form>';
	
	return $ret;
}
?>
