<?php
error_reporting(E_ALL);	
if (!isset($_COOKIE['pid']) OR !is_numeric($_COOKIE['pid']))
{
	header('Location: index.php?logout');
	die();
}
header('Pragma: no-cache');
include_once 'conf/global.php';
include_once 'lib/util.php';
include_once 'lib/tree.php';
function __autoload($class) { include_once 'class/'. $class .'.php'; }

$_db = new Database();

$id_project = intval($_COOKIE['pid']);
$_project = new Project($id_project);

$tree = new Tree($_project->id);
$tree->loadHosts();
$tree->loadPorts();
$tree->loadRoles();
$tree->loadDomains();

echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html><head><title>NSAP - Network security assessment platform</title>
<link rel="stylesheet" href="/css/tree.css" type="text/css"></link>
<script type="text/javascript" src="/jstree/js/jquery.js"></script>
<script type="text/javascript" src="/jstree/js/jquery.hotkeys.js"></script>
<script type="text/javascript" src="/jstree/js/jquery.jstree.js"></script>
<base target="main" />
</head><body>
<script>function loadurl(url){parent.main.location.href = url;return false;}</script>
<table><tr><td width="200"><b>'. $_project->name .'</b><br>
<div id="tree" class="tree" style="height:100px;">
'. build_tree($tree) .'
</div>';
?>

<script type="text/javascript">
$(function () {
	$("#tree")
		.jstree({
			"types" : {
				"valid_children" : [ "port", "host", "subnet" ],
				"types" : {
					"domain" : { "icon" : { "image" : "/img/domain.png" } },
					"port" : { "icon" : { "image" : "/img/port.png" } },
					"host" : { "icon" : { "image" : "/img/host.png" } },
					"subnet" : { "icon" : { "image" : "/img/subnet.png" } },
					"role" : { "icon" : { "image" : "/img/role.png" } },
					"default" : { "valid_children" : [ "default" ] }
				}
			},
			"plugins" : ["themes","html_data","types","ui","hotkeys","sort"],
			"core" : { "initially_open" : [ "domains","hosts","ports", "roles" ] }
		})

		.bind("loaded.jstree", function (event, data) {
			// you get two params - event & data - check the core docs for a detailed description
		});


});
</script></body></html>
